%define anolis_release 1
%global	gem_name	json

Name:           rubygem-%{gem_name}
Version:        2.6.3
Release:        %{anolis_release}%{?dist}

Summary:        A JSON implementation in Ruby

License:        Ruby or BSD
URL:            https://github.com/flori/json
Source0:        https://rubygems.org/downloads/json-%{version}.gem
Source1:        rubygem-%{gem_name}-%{version}-missing-files.tar.gz
# Source1 is created by $ %%SOURCE2 v%%version
Source2:        json-create-tarball-missing-files.sh

BuildRequires:  gcc
BuildRequires:  ruby(release)
BuildRequires:  ruby-devel
BuildRequires:  rubygems-devel
BuildRequires:  rubygem(rake)
BuildRequires:  rubygem(bigdecimal)
BuildRequires:  rubygem(test-unit)

Obsoletes:	rubygem-%{gem_name}-gui < %{version}
Obsoletes:	ruby-%{gem_name}-gui < %{version}
Obsoletes:	ruby-%{gem_name} < %{version}

%description
This is a implementation of the JSON specification according
to RFC 4627 in Ruby.
You can think of it as a low fat alternative to XML,
if you want to store data to disk or transmit it over
a network rather than use a verbose markup language.

%package	doc
Summary:	Documentation for %{name}
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version} -a 1

find . -name extconf.rb | xargs sed -i -e 's|-O3|-O2|' -e 's|-O0|-O2|'

%build
gem build ../%{gem_name}-%{version}.gemspec
%gem_install

find . -name \*gem -exec chmod 0644 {} \;

# remove pure
rm -fr .%{gem_instdir}/lib/json/pure*

%install
mkdir -p %{buildroot}%{gem_dir}
mkdir -p %{buildroot}%{gem_extdir_mri}
 
cp -a .%{gem_dir}/* %{buildroot}/%{gem_dir}
cp -a .%{gem_extdir_mri}/{gem.build_complete,json} %{buildroot}/%{gem_extdir_mri}/

mkdir -p %{buildroot}%{ruby_libdir}
mkdir -p %{buildroot}%{ruby_libarchdir}
ln -s %{gem_libdir}/json.rb %{buildroot}%{ruby_libdir}/json.rb
ln -s %{gem_libdir}/json %{buildroot}%{ruby_libdir}/json
ln -s %{gem_extdir_mri}/json/ %{buildroot}%{ruby_libarchdir}/json

find %{buildroot}%{gem_instdir} -name \*.rb -print0 | \
	xargs --null chmod 0644

# We don't need those files anymore.
pushd %{buildroot}%{gem_instdir}
rm -rf \
	%{gem_name}.gemspec \
	Gemfile \
	ext \
	lib/json/ext \
	java \
	tests \
	%{nil}
popd

%generate_compatibility_deps

%check
rm -rf .%{gem_instdir}/tests
cp -a ./%{gem_name}-%{version}/tests .%{gem_instdir}/

pushd .%{gem_instdir}
ruby -Ilib -e 'Dir.glob "./test/**/*_test.rb", &method(:require)'
popd

%files
%dir %{gem_instdir}
%dir %{gem_libdir}
%dir %{gem_libdir}/%{gem_name}

%doc %{gem_instdir}/CHANGES.md
%license %{gem_instdir}/LICENSE
%doc %{gem_instdir}/README.md
%doc %{gem_instdir}/VERSION

%{gem_libdir}/%{gem_name}.rb
%{gem_libdir}/%{gem_name}/add
%{gem_libdir}/%{gem_name}/common.rb
%{gem_libdir}/%{gem_name}/ext.rb
%{gem_libdir}/%{gem_name}/version.rb
%{gem_libdir}/%{gem_name}/generic_object.rb

%{ruby_libdir}/json*
%{ruby_libarchdir}/json*
%{gem_extdir_mri}/
%{gem_spec}

%dir %{abidir}
%{abidir}/*.dump

%exclude %{gem_cache}

%files      doc
%{gem_docdir}/


%changelog
* Fri Mar 17 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.6.3-1
- init from upstream
